// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robot_calibration_msgs:msg/ExtendedCameraInfo.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__STRUCT_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'camera_info'
#include "sensor_msgs/msg/detail/camera_info__struct.hpp"
// Member 'parameters'
#include "robot_calibration_msgs/msg/detail/camera_parameter__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__robot_calibration_msgs__msg__ExtendedCameraInfo __attribute__((deprecated))
#else
# define DEPRECATED__robot_calibration_msgs__msg__ExtendedCameraInfo __declspec(deprecated)
#endif

namespace robot_calibration_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ExtendedCameraInfo_
{
  using Type = ExtendedCameraInfo_<ContainerAllocator>;

  explicit ExtendedCameraInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : camera_info(_init)
  {
    (void)_init;
  }

  explicit ExtendedCameraInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : camera_info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _camera_info_type =
    sensor_msgs::msg::CameraInfo_<ContainerAllocator>;
  _camera_info_type camera_info;
  using _parameters_type =
    std::vector<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>>;
  _parameters_type parameters;

  // setters for named parameter idiom
  Type & set__camera_info(
    const sensor_msgs::msg::CameraInfo_<ContainerAllocator> & _arg)
  {
    this->camera_info = _arg;
    return *this;
  }
  Type & set__parameters(
    const std::vector<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>> & _arg)
  {
    this->parameters = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_calibration_msgs__msg__ExtendedCameraInfo
    std::shared_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_calibration_msgs__msg__ExtendedCameraInfo
    std::shared_ptr<robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExtendedCameraInfo_ & other) const
  {
    if (this->camera_info != other.camera_info) {
      return false;
    }
    if (this->parameters != other.parameters) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExtendedCameraInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExtendedCameraInfo_

// alias to use template instance with default allocator
using ExtendedCameraInfo =
  robot_calibration_msgs::msg::ExtendedCameraInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace robot_calibration_msgs

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__STRUCT_HPP_
